export default {
  toggleLoading (state, loading = null) {
    state.loading = !!loading
  },
  setUserInfo (state, {name, type}) {
    if (typeof name !== 'string' || name.trim().length === 0) return
    if (typeof type !== 'string' || type.trim().length === 0) return
    name = name.trim()
    type = type.trim()
    state.user = {
      ...state.user,
      name,
      type
    }
  },
  addDialog (state, {msg, act = null}) {
    if (typeof msg !== 'string' || msg.trim().length === 0) return
    state.dialog = [...state.dialog, {msg, act}]
  },
  removeDialog (state) {
    state.dialog = state.dialog.slice(1)
  },
  setChannels (state, list) {
    if (!Array.isArray(list)) return
    state.twitch.channels = [...list]
  },
  setChannel (state, channel = null) {
    if (channel === null || typeof channel !== 'object' || !('id' in channel)) return
    let list = state.twitch.channels.filter(t => t.id !== channel.id)
    state.twitch.channels = [...list, channel]
  },
  setOpaySetting (state, {chid, setting}) {
    if (typeof chid !== 'string' || chid.trim().length === 0) return
    if (typeof setting !== 'object') return
    let list = state.twitch.channels.map(t => {
      if (t.id === chid) {
        t.opaySetting = setting
      }
      return t
    })
    state.twitch.channels = [...list]
  }
}
